{ ****************************************************************** }
{                                                                    }
{   VCL component TPb                                                }

{                                                                    }
{   Copyright  2002 by ...James W Cheek                                          }
{                                                                    }
{ ****************************************************************** }

unit Pb;

interface

uses WinTypes, WinProcs, Messages, SysUtils, Classes, Controls, 
     Forms, Graphics, Extctrls;

type
 TUnPublish = byte;
  TPb = class(TPanel)
    private
       function UnPublish: TUnpublish; virtual; abstract;
procedure Click; override;
      { Private fields of TPb }

      { Private methods of TPb }
        { Method to set variable and property values and create objects }
        procedure AutoInitialize;
        { Method to free any objects created by AutoInitialize }
        procedure AutoDestroy;

    protected
      { Protected fields of TPb }

      { Protected methods of TPb }
        {procedure Click; override;}
        procedure KeyPress(var Key : Char); override;
        procedure Loaded; override;
        procedure Paint; override;

    public
      { Public fields and properties of TPb }

      { Public methods of TPb }
        constructor Create(AOwner: TComponent); override;
        destructor Destroy; override;

    published
      { Published properties of TPb }
        property OnClick;
        property OnDblClick;
        property OnDragDrop;
        property OnEnter;
        property OnExit;
        property OnKeyDown;
        property OnKeyPress;
        property OnKeyUp;
        property OnMouseDown;
        property OnMouseMove;
       property OnMouseUp;
        property OnResize;
        property BevelInner: TUnPublish read UnPublish ;
        property BevelOuter: TUnPublish read UnPublish;
        property BevelWidth default 2;
        property BorderStyle;
        property Color default clAqua;
        property Width default 105;
        property Height default 33;
  end;

procedure Register;

implementation

procedure Register;
begin
     { Register TPb with Samples as its
       default page on the Delphi component palette }
     RegisterComponents('Samples', [TPb]);
end;

{ Method to set variable and property values and create objects }
procedure TPb.AutoInitialize;
begin
inherited     BevelInner := bvRaised;
inherited     BevelOuter := bvRaised;
     BevelWidth := 2;
     BorderStyle := bssingle;
     Color := clAqua;
     Width := 105;
     Height := 33;
end; { of AutoInitialize }

procedure TPb.Click;
label 100;
begin
inherited Click;
if (inherited bevelinner = bvRaised) then
begin
inherited bevelinner := bvlowered ;
inherited bevelouter := bvlowered;
goto 100;
end;
if (inherited bevelinner = bvlowered) then
begin
inherited bevelinner := bvraised;
inherited bevelouter := bvraised;
end;
100: ;
end;



{ Method to free any objects created by AutoInitialize }
procedure TPb.AutoDestroy;
begin
     { No objects from AutoInitialize to free }
end; { of AutoDestroy }

{ Override OnClick handler from TPanel }

{ Override OnKeyPress handler from TPanel }
procedure TPb.KeyPress(var Key : Char);
const
     TabKey = Char(VK_TAB);
     EnterKey = Char(VK_RETURN);
begin
     { Key contains the character produced by the keypress.
       It can be tested or assigned a new value before the
       call to the inherited KeyPress method.  Setting Key
       to #0 before call to the inherited KeyPress method
       terminates any further processing of the character. }

     { Activate KeyPress behavior of parent }
     inherited KeyPress(Key);

     { Code to execute after KeyPress behavior of parent }

end;

constructor TPb.Create(AOwner: TComponent);
begin
     { Call the Create method of the container's parent class       }
     inherited Create(AOwner);

     { AutoInitialize sets the initial values of variables          }
     { (including subcomponent variables) and properties;           }
     { also, it creates objects for properties of standard          }
     { Delphi object types (e.g., TFont, TTimer, TPicture)          }
     { and for any variables marked as objects.                     }
     
     AutoInitialize;

     { Code to perform other tasks when the container is created    }

end;

destructor TPb.Destroy;
begin
     { AutoDestroy, frees any   }
     { objects created by AutoInitialize.                               }
     AutoDestroy;

     { Here, free any other dynamic objects that the component methods  }
     { created but have not yet freed.  Also perform any other clean-up }
     { operations needed before the component is destroyed.             }

     { Last, free the component by calling the Destroy method of the    }
     { parent class.                                                    }
     inherited Destroy;
end;

procedure TPb.Loaded;
begin
     inherited Loaded;

     { Perform any component setup that depends on the property
       values having been set }

end;

procedure TPb.Paint;
begin
     { Make this component look like its parent component by calling
       its parent's Paint method. }
     inherited Paint;

     { To change the appearance of the component, use the methods 
       supplied by the component's Canvas property (which is of 
       type TCanvas).  For example, }

     { Canvas.Rectangle(0, 0, Width, Height); }
end;


end.
